%global gitdate 2017.12.14
%global commit  a20d81c32c7caeb330bbc6b7373ddb975c533e20
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           nodepool
Version:        0.4.0
Release:        1.%{gitdate}.%{shortcommit}%{?dist}
Summary:        Node pool V3 management for a distributed test infrastructure

License:        ASL 2.0
URL:            http://docs.openstack.org/infra/system-config/
Source0:        https://github.com/openstack-infra/nodepool/archive/%{commit}/nodepool-%{version}.tar.gz
Source1:        nodepool-launcher.service
Source2:        nodepool-builder.service
Source3:        nodepool.yaml
Source4:        logging.conf
Source5:        launcher-logging.yaml
Source6:        builder-logging.yaml

Patch1:         0001-Add-a-plugin-interface-for-drivers.patch

BuildArch:      noarch

Requires:       python3
Requires:       python3-pbr
Requires:       python3-PyYAML
Requires:       python3-daemon
Requires:       python3-extras
Requires:       python3-statsd
Requires:       python3-sqlalchemy
Requires:       python3-prettytable
Requires:       python3-six
Requires:       python3-voluptuous
Requires:       python3-kazoo
Requires:       python3-paste
Requires:       python3-webob

BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-setuptools
BuildRequires:  python3-sphinxcontrib-programoutput
BuildRequires:  systemd


%description
Nodepool is a service used by the OpenStack CI team to deploy and manage a pool
of devstack images on a cloud server for use in OpenStack project testing.


%package launcher
Summary:        Nodepool launcher service
Requires:       nodepool

%description launcher
Nodepool launcher service


%package driver-openstack
Summary:        Nodepool OpenStack driver
Requires:       nodepool-launcher
Requires:       python3-os-client-config
Requires:       python3-shade
Requires:       python3-paramiko

%description driver-openstack
Nodepool OpenStack driver


%package builder
Summary:        Nodepool builder service
Requires:       nodepool
Requires:       yum-utils
Requires:       sudo
Requires:       qemu-img

%description builder
Nodepool builder service


%package doc
Summary: The Nodepool documentation

%description doc
The Nodepool documentation


%prep
%autosetup -n nodepool-%{commit} -p1
rm requirements.txt test-requirements.txt

# Remove test files
rm -Rf nodepool/tests nodepool/driver/fake

# Remove interpreter and exec bit
find nodepool/ -type f -exec sed -i '1s=^#!/usr/bin.*==' {} \;
find nodepool/ -type f -exec chmod -x {} \;


%build
PBR_VERSION=%{version} %py3_build
PBR_VERSION=%{version} SPHINX_DEBUG=1 sphinx-build -b html doc/source build/html


%install
PBR_VERSION=%{version} %py3_install

# Empty configuration

# Service unit
install -p -D -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/nodepool-launcher.service
install -p -D -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/nodepool-builder.service

# Basic configuration
install -p -D -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/nodepool/nodepool.yaml
install -p -d -m 0755 %{buildroot}%{_sysconfdir}/nodepool/elements
touch %{buildroot}%{_sysconfdir}/nodepool/secure.conf

install -p -D -m 0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/nodepool/logging.conf
install -p -D -m 0644 %{SOURCE5} %{buildroot}%{_sysconfdir}/nodepool/launcher-logging.yaml
install -p -D -m 0644 %{SOURCE6} %{buildroot}%{_sysconfdir}/nodepool/builder-logging.yaml


# Service base directories
install -p -d -m 0700 %{buildroot}%{_sharedstatedir}/nodepool
install -p -d -m 0700 %{buildroot}%{_sharedstatedir}/nodepool/dib
install -p -d -m 0700 %{buildroot}%{_sharedstatedir}/nodepool/.config/openstack
install -p -d -m 0700 %{buildroot}%{_localstatedir}/log/nodepool
install -p -d -m 0755 %{buildroot}%{_localstatedir}/cache/nodepool/dib_cache
install -p -d -m 0755 %{buildroot}%{_localstatedir}/cache/nodepool/dib_tmp


%pre
getent group nodepool >/dev/null || groupadd -r nodepool
if ! getent passwd nodepool >/dev/null; then
  useradd -r -g nodepool -G nodepool -d %{_sharedstatedir}/nodepool -s /sbin/nologin -c "Nodepool Daemon" nodepool
fi
exit 0


%post launcher
%systemd_post nodepool-launcher.service
%post builder
%systemd_post nodepool-builder.service

%preun launcher
%systemd_preun nodepool-launcher.service
%preun builder
%systemd_preun nodepool-builder.service

%postun launcher
%systemd_postun nodepool-launcher.service
%postun builder
%systemd_postun nodepool-builder.service


%files
%doc LICENSE
%{_bindir}/nodepool
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/nodepool/nodepool.yaml
%config(noreplace) %attr(0640, root, nodepool) %{_sysconfdir}/nodepool/secure.conf
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/nodepool/logging.conf
%dir %{_sysconfdir}/nodepool/elements
%dir %attr(0750, nodepool, nodepool) %{_localstatedir}/log/nodepool
%attr(0750, nodepool, nodepool) %{_sharedstatedir}/nodepool
%exclude %{python3_sitelib}/nodepool/driver/openstack
%{python3_sitelib}/nodepool
%{python3_sitelib}/nodepool-*.egg-info

%files launcher
%doc LICENSE
%{_bindir}/nodepool-launcher
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/nodepool/launcher-logging.yaml
%{_unitdir}/nodepool-launcher.service

%files driver-openstack
%doc LICENSE
%{python3_sitelib}/nodepool/driver/openstack

%files builder
%doc LICENSE
%{_bindir}/nodepool-builder
%config(noreplace) %attr(0644, root, root) %{_sysconfdir}/nodepool/builder-logging.yaml
%{_unitdir}/nodepool-builder.service
%attr(0755, nodepool, nodepool) %{_localstatedir}/cache/nodepool

%files doc
%doc LICENSE build/html


%changelog
* Wed Jan  3 2018 Tristan Cacqueray <tdecacqu@redhat.com> - 0.4.0-1
- Import from software factory repository
